app/main/forms.py
from flask import request
from flask_wtf import FlaskForm
from flask_wtf.file import FileField, FileAllowed,FileRequired
from wtforms import StringField, PasswordField, SubmitField, BooleanField, TextAreaField
from wtforms.validators import DataRequired, Length, Email, EqualTo, ValidationError
from app.models import User
from flask_login import current_user


class UpdateForm(FlaskForm):

    username = StringField('Username', validators=[DataRequired(),Length(min=2,max=15)])
    about_me = TextAreaField('About me', validators=[Length(min=0, max=140)])
    image_file = FileField('Update Profile picture',validators = [FileAllowed(['jpg','png'])])
    submit = SubmitField('Update')

    def validate_username(self,username):
        if username.data != current_user.username:
            user  = User.query.filter_by(username=username.data).first()
            if user:
                raise ValidationError("Oops someone already have this username!!")


class PostForm(FlaskForm):
    image_file = FileField('Snap',validators = [FileRequired(), FileAllowed(['jpg','png'])])
    caption = TextAreaField('Caption',validators=[DataRequired(),Length(min=2,max=150)])
    submit = SubmitField('Post')

class SearchForm(FlaskForm):
    q = StringField(('Search'),validators=[DataRequired()])
    def __init__(self, *args, **kwargs):
        if 'formdata' not in kwargs:
            kwargs['formdata'] = request.args
        if 'csrf_enabled' not in kwargs:
            kwargs['csrf_enabled'] = False
        super(SearchForm, self).__init__(*args, **kwargs)

class CommentForm(FlaskForm):
    body = StringField('Comment',validators=[DataRequired()])
    submit = SubmitField('Submit')

app/main/__init__.py
from flask import Blueprint

bp  = Blueprint('main',__name__)

from app.main import routes

app/main/routes.py
import secrets
from PIL import Image
import os
from app import db, app
from datetime import datetime
from flask import request, current_app, g
from app.main.forms import UpdateForm, PostForm, SearchForm, CommentForm
from app.auth.forms import RegistrationForm
from flask import render_template, url_for, flash, redirect, request
from flask_login import current_user, login_user, logout_user, login_required
from app.models import User, Post, Comment
from app.main import bp


@bp.route("/", methods=['GET', 'POST'])
@bp.route("/home", methods=['GET', 'POST'])
def home():
    if current_user.is_authenticated:
        return redirect(url_for('main.landing'))
    form = RegistrationForm()
    if form.validate_on_submit():
        user = User(email=form.email.data,fullname=form.fullname.data,username=form.username.data,)
        user.set_password(form.password.data)
        db.session.add(user)
        db.session.commit()
        flash("Your account has been created! Now you can login!",'success')
        return redirect(url_for('auth.login'))
    return render_template('auth/home.html',form=form)

@bp.route("/main")
@login_required
def landing():
    posts = current_user.followed_posts().all()
    print(posts)
    return render_template('main/landing.html', title = "Home", posts=posts)

def save_picture(form_picture):
    random_hex=secrets.token_hex(8)
    _,f_ext=os.path.splitext(form_picture.filename)
    picture_fn = random_hex + f_ext
    picture_path = os.path.join(current_app.root_path,'static/pictures', picture_fn)
    output_size = (300,300)
    i = Image.open(form_picture)
    i.thumbnail(output_size)
    i.save(picture_path)
    return picture_fn


@bp.route("/account",methods = ['GET','POST'])
@login_required
def account():
    form = UpdateForm()
    if form.validate_on_submit():
        if form.image_file.data:
            picture_file = save_picture(form.image_file.data)
            current_user.image_file= picture_file
        current_user.username = form.username.data
        current_user.about_me = form.about_me.data
        db.session.commit()
        flash("Your account has been updated!!",'success')
        return redirect(url_for('main.account'))
    elif request.method == 'GET':
        form.username.data = current_user.username
        form.about_me.data = current_user.about_me
    image_file = url_for('static',filename=f'pictures/{current_user.image_file}')
    posts = Post.query.filter_by(user_id=current_user.id)
    return render_template('main/account.html',title="Account",image_file=image_file,posts=posts, form=form)

#user template
@bp.route("/user/<username>")
def user(username):
    user = User.query.filter_by(username=username).first_or_404()
    posts = Post.query.filter_by(user_id=user.id)
    print(posts)
    image_file = url_for('static',filename=f'pictures/{user.image_file}')
    return render_template('main/user.html',user=user,posts=posts,image_file=image_file)

@bp.route('/follow/<username>')
@login_required
def follow(username):
    user = User.query.filter_by(username=username).first()
    image_file = url_for('static',filename=f'pictures/{user.image_file}')
    if user is None:
        flash('User {} not found.'.format(username))
        return redirect(url_for('main.landing'))
    if user == current_user:
        flash('You cannot follow yourself!')
        return redirect(url_for('main.user', username=username))
    current_user.follow(user)
    db.session.commit()
    flash('You are following {}!'.format(username),'success')
    return redirect(url_for('main.user', username=username,image_file=image_file))

@bp.route('/unfollow/<username>')
@login_required
def unfollow(username):
    user = User.query.filter_by(username=username).first()
    image_file = url_for('static',filename=f'pictures/{user.image_file}')
    if user is None:
        flash('User {} not found.'.format(username))
        return redirect(url_for('main.landing'))
    if user == current_user:
        flash('You cannot unfollow yourself!','danger')
        return redirect(url_for('main.user', username=username))
    current_user.unfollow(user)
    db.session.commit()
    flash('You are not following {}.'.format(username),'info')
    return redirect(url_for('main.user', username=username,image_file=image_file))


@bp.route("/post/new",methods = ['GET','POST'])
@login_required
def new_post():
    image_file = url_for('static',filename=f'pictures/{current_user.image_file}')
    form = PostForm()
    if form.validate_on_submit():
        picture_file = save_picture(form.image_file.data)
        post = Post(image_file=picture_file,caption=form.caption.data,user_id=current_user.id)
        db.session.add(post)
        db.session.commit()
        flash('Hurray you posted something new!!','success')
        return redirect(url_for('main.landing'))
    return render_template('main/create_post.html',title='New Post',form=form,image_file=image_file)

@bp.route('/like/<int:post_id>/<action>')
@login_required
def like_action(post_id, action):
    post = Post.query.filter_by(id=post_id).first_or_404()
    if action == 'like':
        current_user.like_post(post)
        db.session.commit()
    if action == 'unlike':
        current_user.unlike_post(post)
        db.session.commit()
    return redirect(request.referrer)

@bp.before_app_request
def before_request():
    g.search_form = SearchForm()

@bp.route('/search')
def search():
    if not g.search_form.validate():
        return redirect(url_for('main.landing'))
    user,hit = User.search(g.search_form.q.data)
    return render_template('search.html', title=('Search'), user=user) if hit!=0 else render_template('search.html', title=('Search'))

@bp.route('/comments/<int:post_id>',methods=['GET','POST'])
def create_comment(post_id):
    post = Post.query.filter_by(id=post_id).first_or_404()
    form = CommentForm()
    comments = Comment.query.filter_by(post_id=post_id).all()
    if form.validate_on_submit():
        comment = Comment(body=form.body.data,commenter=current_user,comment_post=post)
        db.session.add(comment)
        db.session.commit()
        return redirect(url_for('main.create_comment',post_id=post_id))
    return render_template('main/comment_section.html',post=post,form=form,comments=comments)

app/templates/main/account.html
{% extends "layout.html" %}
{% block content %}
<div class="container">
    <div class="row">
        <div class="col-md-4 col-sm-6">
            <div class="media">
                <img class="rounded-circle account-img" src="{{image_file}}">
            </div>
            <div>
                <button type="button"
                    class="btn btn-info edit-profile-button ml-4"
                    data-toggle="modal" data-target="#myModal">Edit
                    Profile</button>
            </div>
        </div>
        <div class="col-md-8 col-sm-6">
            <div class="media-body">
                <h4 class="account-heading">
                    <i><b>{{current_user.username}}</b></i>
                </h4>
                <p><b>{{ current_user.followers.count() }}</b> followers
                    &nbsp;&nbsp; <b>{{current_user.followed.count()}}</b>
                    following
                </p>
                <p class="text-bold"><b>{{current_user.fullname}}</b></p>
                {% if current_user.about_me %}
                <p>{{ current_user.about_me }}</p>
                {% endif %}
            </div>
        </div>
    </div>
</div>
<div id="myModal" class="modal fade" role="dialog">
    <div class="modal-dialog">
        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Edit
                    Profile</h4>
                <button type=" button" class="close"
                    data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
                <form action="" method="POST" enctype="multipart/form-data">
                    {{form.hidden_tag()}}
                    <fieldset class="form-group">
                        <div class="form-group">
                            {{ form.username.label(class='form-control-label') }}
                            {% if form.username.errors %}
                            {{ form.username(class='form-control is-invalid') }}
                            <div class="invalid-feedback">
                                {% for error in form.username.errors %}
                                <span>{{ error }}</span>
                                {% endfor %}
                            </div>
                            {% else %}
                            {{ form.username(class='form-control', placeholder="Username..") }}
                            {% endif %}
                        </div>
                        <div class="form-group">
                            {{ form.about_me.label(class='form-control-label') }}
                            {% if form.about_me.errors %}
                            {{ form.about_me(class='form-control is-invalid') }}
                            <div class="invalid-feedback">
                                {% for error in form.about_me.errors %}
                                <span>{{ error }}</span>
                                {% endfor %}
                            </div>
                            {% else %}
                            {{ form.about_me(class='form-control', placeholder="Update your info...", rows=4) }}
                            {% endif %}
                        </div>
                        <div class="form-group">
                            {{form.image_file.label() }}
                            {{ form.image_file(class="form-control-file")}}
                            {% if form.image_file.errors %}
                            {% for error in form.image_file.errors %}
                            <span class="text-danger">{{error}}</span><br>
                            {% endfor %}
                            {% endif %}
                        </div>
                    </fieldset>
                    <div class="form-group">
                        {{ form.submit(class = "btn btn-outline-danger btn-block") }}
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
<!-- FORM HERE -->
<div class="container">
    <div class="row">
        {% for post in posts %}
        <div class="col-lg-3 col-md-6 col-sm-12 card post-content">
            <img id="myImg" class="post-image rounded"
                src="{{ url_for('static',filename='pictures/')}}{{post.image_file}}"
                alt="Post" ">
            {% if post.likes.count() != 0 %}
            <p>{{ post.likes.count() }}&nbsp;<i class=" fa fa-trophy"
                aria-hidden="true"></i>
            </p>
            {% else %}
            <p><i class="fa fa-frown-o" aria-hidden="true"></i>
            </p>
            {% endif %}
            <h3>{{ post.author.username }}</h3>
            <p>{{ post.caption }}</p>
        </div>
        {% endfor %}
    </div>
</div>
{% endblock content %}

app/templates/main/comment_section.html
{% extends "layout.html" %}
{% block content %}
<div class="container">
    <div class="jumbotron ">
        <h1>Comments</h1>
        <img src="{{ url_for('static',filename='pictures/')
    }}{{ post.image_file }}" alt="">
        <p>{{ post.caption }}</p>
    </div>
    <table class="table table.striped">
        {% for comment in comments %}
        <tr>
            <td>
                {{ comment.commenter.username}}
            </td>
            <td>
                {{ comment.body }}
            </td>
        </tr>
        {% endfor %}
    </table>
    <div class="col-lg-12 col-md-12">
        <form action="" method="POST">
            {{ form.hidden_tag() }}
            <fieldset class="form-group">
                <div class="form-group">
                    {{ form.body.label(class='form-control-label') }}
                    {% if form.body.errors %}
                    {{ form.body(class='form-control is-invalid') }}
                    <div class="invalid-feedback">
                        {% for error in form.body.errors %}
                        <span>{{ error }}</span>
                        {% endfor %}
                    </div>
                    {% else %}
                    {{ form.body(class='form-control' , placeholder='comment..') }}
                    {% endif %}
                </div>
                <div class="form-group">
                    {{ form.submit(class = "btn btn-outline-primary mr-auto") }}
                </div>
            </fieldset>
        </form>
    </div>
</div>
{% endblock %}

app/templates/main/create_post.html
{% extends "layout.html" %}
{% block content %}
<div class="container">
    <div class="row back new-post-page">
        <div class="col-lg-6 col-md-12 col-sm-6 post-left">
            <img class="rounded-circle postpage-img" src="{{image_file}}">
            <h1>{{current_user.username}}</h1>
        </div>
        <div class="col-lg-6 col-md-12 col-sm-6 post-right card">
            <form method="POST" enctype="multipart/form-data">
                {{ form.hidden_tag() }}
                <div class="form-group">
                    {{form.image_file.label() }}
                    {{ form.image_file(class="form-control-file")}}
                    {% if form.image_file.errors %}
                    {% for error in form.image_file.errors %}
                    <span class="text-danger">{{error}}</span><br>
                    {% endfor %}
                    {% endif %}
                </div>
                <div class="form-group">
                    {{ form.caption.label(class='form-control-label') }}
                    {% if form.caption.errors %}
                    {{ form.caption(class='form-control is-invalid') }}
                    <div class="invalid-feedback">
                        {% for error in form.caption.errors %}
                        <span>{{ error }}</span>
                        {% endfor %}
                    </div>
                    {% else %}
                    {{ form.caption(class='form-control', rows=6) }}
                    {% endif %}
                </div>
                <div class="form-group">
                    {{ form.submit(class = "btn btn-outline-danger btn-block") }}
                </div>
            </form>
        </div>
    </div>
</div>
{% endblock %}

app/templates/main/landing.html
{% extends "layout.html" %} {% block content %}
<div class="container">
    <div class=" post-feed-header">
        <h1 class="display-10 text-center">Feed</h1>
        <p class="lead text-center">You can see what you have followed!!</p>
    </div>
    <div class="row">
        {% for post in posts %}
        <div class="col-md-4 col-sm-9 card post-content">
            <img id="myImg" class="post-image rounded" src="{{ url_for('static',filename='pictures/')
      }}{{ post.image_file }}" alt="Post" ">
      <h3>{{ post.author.username }}</h3>
      <p>{{ post.caption }}</p>
      {% if current_user.is_authenticated %} {% if
      current_user.has_liked_post(post) %}
      <a
        href=" {{ url_for('main.like_action', post_id=post.id, action='unlike') }}"
                class="like"><i class="fa fa-thumbs-down"
                aria-hidden="true"></i>Unlike</a>
            {% else %}
            <a href="{{ url_for('main.like_action', post_id=post.id, action='like') }}"
                class="like"><i class="fa fa-heart fa-1.5x"
                    aria-hidden="true"></i>&nbsp;&nbsp;Like</a>
            {% endif %}
            <span>{{ post.likes.count() }} likes</span>
            <a
                href="{{ url_for('main.create_comment',post_id=post.id) }}">Comments</a>

            {% endif %}
        </div>
        {% endfor %}
    </div>
</div>

{% endblock content %}

app/templates/main/user.html
{% extends "layout.html" %}
{% block content %}
<div class="container">
    <div class="row">
        <div class="col-md-6">
            <h3><span> <img class="rounded-circle account-img"
                        src="{{image_file}}">
                </span> </h3>
            <h3>{{user.username}}</h3>
            {% if user.about_me %}<p>{{ user.about_me }}</p>{% endif %}
        </div>
        <div class="col-md-3">
            <h3 style="margin-left: 1em">{{ user.followers.count() }}</h3><br>
            <p><b>followers</b></p>
        </div>
        <div class="col-md-3">
            <h3 style="margin-left: 1em">{{user.followed.count()}}</h3><br>
            <p><b>following</b></p>
        </div>
    </div>
    {% if current_user.is_authenticated %}
    {% if user == current_user %}
    <p><a href="{{ url_for('main.account') }}">Edit your profile</a></p>
    {% elif not current_user.is_following(user)%}
    <p><a href="{{ url_for('main.follow', username=user.username) }}">Follow</a>
    </p>
    {% else %}
    <p><a
            href="{{ url_for('main.unfollow', username=user.username) }}">Unfollow</a>
    </p>
    {% endif %}
    {% else %}
    <div class="alert alert-info" role="alert">
        <strong>You must log in to Follow/Unfollow this user.</strong>
    </div>
    {% endif %}
</div>
<div class="container">
    <h3 class="ml-2">Posts:</h3>
    <div class="row">
        {% for post in posts %}
        <div class="col-md-4 card ml-2">
            <img src="{{ url_for('static',filename='pictures/')}}{{post.image_file}}"
                alt="" class="post-image">
            <p>{{ post.caption }}</p>
        </div>
        {% endfor %}
    </div>

</div>
{% endblock %}